require "openssl"
module Sekreti
  # Main class performing operations.
  class Core

    protected
    # Encrypts a file with AES-128-CBC cipher, using
    # a submitted 16 bytes string.
    # @param options [Hash] submitted parameters
    # @return boolean
    def self.encrypt!(options)
      begin
        cipher = OpenSSL::Cipher.new(options[:protocol])
        cipher.encrypt
        cipher.key = options[:key]

        f = File.open(
          options[:output_file], 
          'wb'
        )
        
        encrypted = cipher.update(File.read(options[:path])) + cipher.final
        f.write(encrypted)

        return true
      rescue
        return false
      end
    end

    # Decrypts a file with a submitted key.
    # @param options [Hash] submitted parameters
    # @return boolean
    def self.decrypt!(options)
      begin
        decipher = OpenSSL::Cipher.new(options[:protocol])
        decipher.decrypt
        decipher.key =  options[:key]
    
        f = File.open(options[:output_file], 'w')
        decrypted = decipher.update(File.read(options[:path])) + decipher.final
        f.write(decrypted)

        return true
      rescue
        return false
      end
    end
  end
end